
from paraview.simple import *
from paraview import coprocessing


#--------------------------------------------------------------
# Code generated from cpstate.py to create the CoProcessor.
# ParaView 5.3.0 64 bits


# ----------------------- CoProcessor definition -----------------------

def CreateCoProcessor():
  def _CreatePipeline(coprocessor, datadescription):
    class Pipeline:
      # state file generated using paraview version 5.3.0

      # ----------------------------------------------------------------
      # setup views used in the visualization
      # ----------------------------------------------------------------

      #### disable automatic camera reset on 'Show'
      paraview.simple._DisableFirstRenderCameraReset()

      # Create a new 'Render View'
      renderView1 = CreateView('RenderView')
      renderView1.ViewSize = [1113, 756]
      renderView1.InteractionMode = '2D'
      renderView1.AxesGrid = 'GridAxes3DActor'
      renderView1.CenterOfRotation = [-77.36604544860647, 23.486562272948845, 0.0]
      renderView1.StereoType = 0
      renderView1.CameraPosition = [-77.36604544860647, 23.486562272948845, 143.99432596285266]
      renderView1.CameraFocalPoint = [-77.36604544860647, 23.486562272948845, 0.0]
      renderView1.CameraParallelScale = 37.26847394588663
      renderView1.Background = [0.32, 0.34, 0.43]

      # register the view with coprocessor
      # and provide it with information such as the filename to use,
      # how frequently to write the images, etc.
      coprocessor.RegisterView(renderView1,
          filename='image_s1_%t.png', freq=1, fittoscreen=0, magnification=1, width=1113, height=756, cinema={})
      renderView1.ViewTime = datadescription.GetTime()

      # ----------------------------------------------------------------
      # setup the data processing pipelines
      # ----------------------------------------------------------------

      # create a new 'XML MultiBlock Data Reader'
      # create a producer from a simulation input
      atm_input2d_3vtm = coprocessor.CreateProducer(datadescription, 'atm_input2d')

      # ----------------------------------------------------------------
      # setup color maps and opacity mapes used in the visualization
      # note: the Get..() functions create a new object, if needed
      # ----------------------------------------------------------------

      # get color transfer function/color map for 'topo'
      topoLUT = GetColorTransferFunction('topo')
      topoLUT.RGBPoints = [0.0, 0.231373, 0.298039, 0.752941, 1733.1236204565378, 0.865003, 0.865003, 0.865003, 3466.2472409130755, 0.705882, 0.0156863, 0.14902]
      topoLUT.ScalarRangeInitialized = 1.0

      # get opacity transfer function/opacity map for 'topo'
      topoPWF = GetOpacityTransferFunction('topo')
      topoPWF.Points = [0.0, 0.0, 0.5, 0.0, 3466.2472409130755, 1.0, 0.5, 0.0]
      topoPWF.ScalarRangeInitialized = 1

      # ----------------------------------------------------------------
      # setup the visualization in view 'renderView1'
      # ----------------------------------------------------------------

      # show data from atm_input2d_3vtm
      atm_input2d_3vtmDisplay = Show(atm_input2d_3vtm, renderView1)
      # trace defaults for the display properties.
      atm_input2d_3vtmDisplay.Representation = 'Surface'
      atm_input2d_3vtmDisplay.ColorArrayName = ['POINTS', 'topo']
      atm_input2d_3vtmDisplay.LookupTable = topoLUT
      atm_input2d_3vtmDisplay.OSPRayScaleArray = 'mask'
      atm_input2d_3vtmDisplay.OSPRayScaleFunction = 'PiecewiseFunction'
      atm_input2d_3vtmDisplay.SelectOrientationVectors = 'None'
      atm_input2d_3vtmDisplay.ScaleFactor = 6.2690730052172885
      atm_input2d_3vtmDisplay.SelectScaleArray = 'None'
      atm_input2d_3vtmDisplay.GlyphType = 'Arrow'
      atm_input2d_3vtmDisplay.PolarAxes = 'PolarAxesRepresentation'
      atm_input2d_3vtmDisplay.ScalarOpacityUnitDistance = 2.187782201235087

      # show color legend
      atm_input2d_3vtmDisplay.SetScalarBarVisibility(renderView1, True)

      # setup the color legend parameters for each legend in this view

      # get color legend/bar for topoLUT in view renderView1
      topoLUTColorBar = GetScalarBar(topoLUT, renderView1)
      topoLUTColorBar.Title = 'topo'
      topoLUTColorBar.ComponentTitle = ''

      # ----------------------------------------------------------------
      # finally, restore active source
      SetActiveSource(atm_input2d_3vtm)
      # ----------------------------------------------------------------
    return Pipeline()

  class CoProcessor(coprocessing.CoProcessor):
    def CreatePipeline(self, datadescription):
      self.Pipeline = _CreatePipeline(self, datadescription)

  coprocessor = CoProcessor()
  # these are the frequencies at which the coprocessor updates.
  freqs = {'atm_input2d': [1]}
  coprocessor.SetUpdateFrequencies(freqs)
  return coprocessor

#--------------------------------------------------------------
# Global variables that will hold the pipeline for each timestep
# Creating the CoProcessor object, doesn't actually create the ParaView pipeline.
# It will be automatically setup when coprocessor.UpdateProducers() is called the
# first time.
coprocessor = CreateCoProcessor()

#--------------------------------------------------------------
# Enable Live-Visualizaton with ParaView
coprocessor.EnableLiveVisualization(False, 1)


# ---------------------- Data Selection method ----------------------

def RequestDataDescription(datadescription):
    "Callback to populate the request for current timestep"
    global coprocessor
    print("SCRIPT1 RDD time ", datadescription.GetTime(), " time step ", datadescription.GetTimeStep())
    if datadescription.GetForceOutput() == True:
        # We are just going to request all fields and meshes from the simulation
        # code/adaptor.
        for i in range(datadescription.GetNumberOfInputDescriptions()):
            datadescription.GetInputDescription(i).AllFieldsOn()
            datadescription.GetInputDescription(i).GenerateMeshOn()
        return

    # setup requests for all inputs based on the requirements of the
    # pipeline.
    coprocessor.LoadRequestedData(datadescription)

# ------------------------ Processing method ------------------------

def DoCoProcessing(datadescription):
    "Callback to do co-processing for current timestep"
    global coprocessor

    print("SCRIPT1 DCP time ", datadescription.GetTime(), " time step ", datadescription.GetTimeStep())
    # Update the coprocessor by providing it the newly generated simulation data.
    # If the pipeline hasn't been setup yet, this will setup the pipeline.
    coprocessor.UpdateProducers(datadescription)

    # Write output data, if appropriate.
    coprocessor.WriteData(datadescription);

    # Write image capture (Last arg: rescale lookup table), if appropriate.
    coprocessor.WriteImages(datadescription, rescale_lookuptable=False)

    # Live Visualization, if enabled.
    coprocessor.DoLiveVisualization(datadescription, "localhost", 22222)
